# Types of formulae

class BooleanType(object):
    def toString(self, funstyle=True):
        if funstyle:
            return "() Bool"
        else:
            return "Bool"
    pass


class RealType(object):
    def toString(self, funstyle=True):
        if funstyle:
            return "() Real"
        else:
            return "Real"
    pass


class FunctionType(object):
    
    def __init__(self, returnType, paramTypes):
        self.returnType = returnType
        self.paramTypes = paramTypes
        return

    
    def toString(self):
        res = "("
        for p in self.paramTypes:
            res = res + p.toString(False) + " "

        res = res + ") " + self.returnType.toString(False)
        return res

    pass



class Types(object):

    def __init__(self):
        self.functions = {}
        return

    BOOL = BooleanType()

    REAL = RealType()

    pass
